/*
 Volume Rendering Demo
 
 MIT License
 
 Copyright (c) 2011, Markus Broecker <mbroecker@gmail.com>
 
 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:
 
 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.
 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
 */


struct OrbitCamera
{
	struct Vec3
	{
		float	x, y, z;
		
		inline Vec3(float X=0.f, float Y=0.f, float Z=0.f) : x(X), y(Y), z(Z) {}
		
		inline Vec3 operator + (const Vec3& b) const { return Vec3(x+b.x, y+b.y, z+b.z); }
	
		inline const Vec3& set(float X, float Y, float Z) { x=X; y=Y; z=Z; return *this; }
	};
	
	Vec3		position, target, up;
		
	float		theta, phi, radius;;
	float		fov, ratio, near, far;
		
	OrbitCamera();
	
	void setup() const;
	
	void rotateTo(float x, float y);
	void rotate(float x, float y);
	
	void updatePosition();
};
